//: C08:Recycle.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
//{L} Trash
// Odpoadkový koš.
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <typeinfo>
#include <vector>
#include "Trash.h"
#include "../purge.h"
using namespace std;

// Sečte hodnotu odpadků v koši:
template<class Container>
void sectiHodnotu(Container& kos, ostream& os) {
  typename Container::iterator seznam = kos.begin();
  float hod = 0;
  while(seznam != kos.end()) {
    hod += (*seznam)->vaha() * (*seznam)->hodnota();
    os << "váha: " << typeid(**seznam).name()
       << " = " << (*seznam)->vaha() << endl;
    ++seznam;
  }
  os << "Ceková hodnota = " << hod << endl;
}

int main() {
  srand(time(0)); // Seed the random number generator
  vector<Kos*> kos;
  // Napnit koš:
  for(int i = 0; i < 30; i++)
    switch(rand() % 3) {
      case 0 :
        kos.push_back(new Hlinik((rand() % 1000)/10.0));
        break;
      case 1 :
        kos.push_back(new Papir((rand() % 1000)/10.0));
        break;
      case 2 :
        kos.push_back(new Sklo((rand() % 1000)/10.0));
        break;
    }
  // Poznámka: koše uchovávají přesný typ odpadků, ne základní typ:
  vector<Sklo*> kosNaSklo;
  vector<Papir*> kosNaPapir;
  vector<Hlinik*> kosNaHlinik;
  vector<Kos*>::iterator tridic = kos.begin();
  // roztřídit Kos:
  while(tridic != kos.end()) {
    Hlinik* kh = dynamic_cast<Hlinik*>(*tridic);
    Papir* kp = dynamic_cast<Papir*>(*tridic);
    Sklo* ks = dynamic_cast<Sklo*>(*tridic);
    if(kh) kosNaHlinik.push_back(kh);
    else if(kp) kosNaPapir.push_back(kp);
    else if(ks) kosNaSklo.push_back(ks);
    ++tridic;
  }
  sectiHodnotu(kosNaHlinik, cout);
  sectiHodnotu(kosNaPapir, cout);
  sectiHodnotu(kosNaSklo, cout);
  sectiHodnotu(kos, cout);
  purge(kos);
} ///:~
